var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var cmdm = require('../lib/tfcommand');
var Q = require('q');
var argm = require('../lib/arguments');
var trace = require('../lib/trace');
// export ID=tfx build get 5 | tfx parse .id
// export ID=tfx build query --top 1 | tfx parse [0].id
function describe() {
    return 'parse json by piping json result from another tfx command';
}
exports.describe = describe;
function getCommand() {
    // this just offers description for help and to offer sub commands
    return new Parse();
}
exports.getCommand = getCommand;
// doesn't require auth, connect etc...
exports.isServerOperation = false;
// since this is parsing and assign output to script variable, we can't have banner showing
exports.hideBanner = true;
var Parse = (function (_super) {
    __extends(Parse, _super);
    function Parse() {
        _super.apply(this, arguments);
        this.requiredArguments = [argm.JSON_FILTER];
    }
    Parse.prototype.exec = function (args, options) {
        trace('parse.exec');
        var defer = Q.defer();
        return this.checkArguments(args, options).then(function (allArguments) {
            var filter = allArguments[argm.JSON_FILTER.name];
            var contents = '';
            process.stdin.resume();
            process.stdin.setEncoding('utf8');
            process.stdin.on('data', function (data) {
                contents += data.toString();
            });
            process.stdin.on('end', function () {
                try {
                    var obj = JSON.parse(contents);
                    process.stdout.write(eval('obj' + filter));
                    defer.resolve({});
                }
                catch (err) {
                    console.error(err.message);
                }
            });
        })
            .fail(function (err) {
            trace('Failed to gather inputs. Message: ' + err.message);
            defer.reject(err);
        });
        return defer.promise;
    };
    Parse.prototype.output = function (creds) {
        // not s server operation
    };
    return Parse;
})(cmdm.TfCommand);
exports.Parse = Parse;
