var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
//TODO: add validity check (length, regex, etc...)
var Argument = (function () {
    function Argument(name, friendlyName, defaultValue) {
        if (friendlyName === void 0) { friendlyName = name; }
        if (defaultValue === void 0) { defaultValue = null; }
        this.silent = false;
        this.name = name;
        this.friendlyName = friendlyName;
        this.defaultValue = defaultValue;
    }
    Argument.prototype.getValueFromString = function (stringRepresentation) {
        return stringRepresentation;
    };
    return Argument;
})();
exports.Argument = Argument;
var BooleanArgument = (function (_super) {
    __extends(BooleanArgument, _super);
    function BooleanArgument() {
        _super.apply(this, arguments);
        this.defaultValue = false;
    }
    BooleanArgument.prototype.getValueFromString = function (stringRepresentation) {
        return ((stringRepresentation.toLowerCase() === "true") || (stringRepresentation === "1"));
    };
    return BooleanArgument;
})(Argument);
exports.BooleanArgument = BooleanArgument;
var FilePathArgument = (function (_super) {
    __extends(FilePathArgument, _super);
    function FilePathArgument() {
        _super.apply(this, arguments);
    }
    FilePathArgument.prototype.getValueFromString = function (stringRepresentation) {
        return stringRepresentation.replace(/(^\")|(\"$)/g, "");
    };
    return FilePathArgument;
})(Argument);
exports.FilePathArgument = FilePathArgument;
var IntArgument = (function (_super) {
    __extends(IntArgument, _super);
    function IntArgument() {
        _super.apply(this, arguments);
    }
    IntArgument.prototype.getValueFromString = function (stringRepresentation) {
        return parseInt(stringRepresentation) || stringRepresentation;
    };
    return IntArgument;
})(Argument);
exports.IntArgument = IntArgument;
var SilentStringArgument = (function (_super) {
    __extends(SilentStringArgument, _super);
    function SilentStringArgument() {
        _super.apply(this, arguments);
        this.silent = true;
    }
    return SilentStringArgument;
})(Argument);
exports.SilentStringArgument = SilentStringArgument;
var StringArgument = (function (_super) {
    __extends(StringArgument, _super);
    function StringArgument() {
        _super.apply(this, arguments);
    }
    return StringArgument;
})(Argument);
exports.StringArgument = StringArgument;
function identity(arg) {
    return arg;
}
exports.identity = identity;
///GENERAL
exports.AUTHOR = new StringArgument('author');
exports.DESCRIPTION = new StringArgument('description');
exports.FRIENDLY_NAME = new StringArgument('friendlyname', 'friendly name');
exports.OVERWRITE = new BooleanArgument('overwrite');
exports.PROJECT_NAME = new StringArgument('project', 'projectName');
///CORE
exports.AUTH_TYPE = new StringArgument('authtype', 'authtype', 'pat');
exports.COLLECTION_URL = new StringArgument('collectionurl', 'collection url');
exports.PASSWORD = new SilentStringArgument('password');
exports.PAT = new SilentStringArgument('token', 'personal access token');
exports.USERNAME = new StringArgument('username');
///BUILD
exports.BUILD_ID = new IntArgument('id', 'buildId');
exports.DEFINITION_ID = new IntArgument('definitionid');
exports.DEFINITION_NAME = new StringArgument('definitionname');
exports.STATUS = new StringArgument('status');
exports.TOP = new IntArgument('top');
///TASKS
exports.ALL = new BooleanArgument('all');
exports.JSON_FILTER = new StringArgument('jsonfilter');
exports.TASK_ID = new StringArgument('id', 'taskId');
exports.TASK_NAME = new StringArgument('name', 'short task name');
exports.TASK_PATH = new FilePathArgument('taskpath');
